local Talented = Talented
local ipairs = ipairs

local L = LibStub("AceLocale-3.0"):GetLocale("Talented")

function Talented:ImportWowTemplate(url, dst)
	local s, _, class, src = url:find(".*/(.*)/talents%..-%?t?a?l?=?(%d+)$")
	if not s then
		return
	end

	dst.class = class:upper()
	local count = 1
	local info = self:UncompressSpellData(dst.class)
	local len = src:len()

	for tab, tree in ipairs(info) do
		local t = {}
		dst[tab] = t
		for index = 1, #tree do
			t[index] = tonumber(src:sub(count, count))
			count = count + 1
			if count > len then break end
		end
	end
	return dst
end
Talented.importers[".*/(.*)/talents%..-%?t?a?l?=?(%d+)$"] = Talented.ImportWowTemplate

function Talented:ExportWowTemplate(template)
	if not RAID_CLASS_COLORS[template.class] then return end
	local s = {}
	for _, tree in ipairs(template) do
		for _, n in ipairs(tree) do
			s[#s + 1] = tostring(n)
		end
	end
	return L["http://www.worldofwarcraft.com/info/classes/%s/talents.html?tal=%s"]:format(template.class:lower(), table.concat(s))
end
Talented.exporters[L["Blizzard Talent Calculator"]] = Talented.ExportWowTemplate

function Talented:ImportWowheadTemplate(url, dst)
	local s, _, code = url:find(".*/%?talent=(.*)$")
	if not s or not code then
		return
	end
	local res, val, class = pcall(self.StringToTemplate, self, code, dst, "0zMcmVokRsaqbdrfwihuGINALpTjnyxtgevE")
	if not res then
		return
	end
	dst.class = class
	return dst
end
Talented.importers["/%?talent="] = Talented.ImportWowheadTemplate

function Talented:ExportWowheadTemplate(template)
	if not RAID_CLASS_COLORS[template.class] then return self:ExportWhpetTemplate(template) end
	return L["http://www.wowhead.com/?talent=%s"]:format(self:TemplateToString(template, "0zMcmVokRsaqbdrfwihuGINALpTjnyxtgevE"))
end
Talented.exporters[L["Wowhead Talent Calculator"]] = Talented.ExportWowheadTemplate
